## metkit 1.6.0

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

########################################################################################################################

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( metkit LANGUAGES CXX )

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features" )
# GRIB support

ecbuild_add_option( FEATURE GRIB
                    DEFAULT ON
                    DESCRIPTION "Add support for GRIB format (grib_api not supported)"
                    REQUIRED_PACKAGES "NAME eccodes VERSION 2.5" )

# BUFR support

ecbuild_add_option( FEATURE BUFR
                    DEFAULT OFF
                    DESCRIPTION "Add support for BUFR4 format"
                    REQUIRED_PACKAGES "NAME eccodes VERSION 2.8" )

# netcdf support

ecbuild_add_option( FEATURE NETCDF
  DEFAULT ON
  DESCRIPTION "Support for NetCDF data"
  REQUIRED_PACKAGES NetCDF
)

# ODB support

ecbuild_add_option( FEATURE ODB
                    DEFAULT ON
                    DESCRIPTION "Add support for ODB data"
                    REQUIRED_PACKAGES "NAME odc VERSION 1.0" )

# eckit

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_find_package( NAME eckit  VERSION  1.11 REQUIRED )

############################################################################################
# sources

add_subdirectory( src )
add_subdirectory( share )

############################################################################################
# finalize

ecbuild_pkgconfig( NAME metkit
                   DESCRIPTION "ECMWF Meteorological toolkit"
                   LIBRARIES metkit )

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== debian/changelog ===
metkit (1.6.0-3) unstable; urgency=medium

  * Add B-D on libodc-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Nov 2020 11:24:35 +0000

metkit (1.6.0-2) unstable; urgency=medium

  * libmetkit-data conflicts with libodb-api-data
  * Build-depend on eccodes and tools
  * Add B-D on libnetcdf-dev, libopenjp2-7-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Oct 2020 11:27:23 +0000

metkit (1.6.0-1) unstable; urgency=medium

  * Initial release. (Closes: #972624)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 21 Oct 2020 15:19:57 +0100

=== debian/control ===
Source: metkit
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 ecbuild (>= 3.3.0-3),
 gfortran | fortran-compiler, 
 libeckit-dev,
 libodc-dev,
 libeccodes-dev,
 libeccodes-tools,
 libnetcdf-dev,
 libopenjp2-7-dev
Standards-Version: 4.5.0
Homepage: https://github.com/ecmwf/metkit
Vcs-Browser: https://salsa.debian.org:/science-team/metkit.git
Vcs-Git: https://salsa.debian.org:/science-team/metkit.git -b debian/latest

Package: libmetkit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetkit-data
Description: Library for Meteorology tookit, implementing MARS language
 MetKit is a toolkit from ECMWF for manipulating and describing 
 meteorological objects, implementing the MARS language and associated 
 processing and semantics.
 MARS is the Meteorological Archive Retrieval System from ECMWF.

Package: libmetkit-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: libodb-api-data
Description: Data used by the ECMWF Metkit Library
 MetKit is a toolkit from ECMWF for manipulating and describing 
 meteorological objects, implementing the MARS language and associated 
 processing and semantics.
 .
 This package contains data used by Metkit

Package: libmetkit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmetkit0d (= ${binary:Version}), 
  ${misc:Depends}, libeckit-dev
Replaces: libodb-api-dev
Conflicts: libodb-api-dev
Recommends: pkg-config
Description: Development files for the Metkit toolkit
 MetKit is a toolkit from ECMWF for manipulating and describing 
 meteorological objects, implementing the MARS language and associated 
 processing and semantics.
 .
 This package provides shared libraries and headers.

Package: libmetkit-utils
Multi-Arch: foreign
Architecture: any
Depends: libmetkit0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libmetkit-dev (= ${binary:Version})
Description: Utilities for the MetKit MARS access library
 MetKit is a toolkit from ECMWF for manipulating and describing 
 meteorological objects, implementing the MARS language and associated 
 processing and semantics.
 .
 This package contains the tool 'parse-mars-request'

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(FC),f77)
  FC:=$(shell basename $(shell readlink /etc/alternatives/f77))
endif

# The magic debhelper  rule
%:
	dh $@ --buildsystem=ecbuild

CMAKE_CFLAGS:= -DENABLE_FORTRAN=ON \
		-DENABLE_RPATH=OFF \
		-DENABLE_RELATIVE_RPATHS=OFF

override_dh_auto_configure:
	dh_auto_configure -- \
                      ${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=$(FC)

override_dh_auto_test:
	echo "Metkit fetches data from the internet, and hence the tests can't be run contained at build-time"

## metkit 1.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -65,6 +65,8 @@
 ############################################################################################
 # sources
 
+include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings
+
 add_subdirectory( src )
 add_subdirectory( share )

=== share/metkit/CMakeLists.txt ===
list( APPEND files language.yaml paramids.yaml params.yaml wind )

foreach( _file ${files} )

    configure_file( ${_file} ${CMAKE_BINARY_DIR}/share/metkit/${_file} COPYONLY )

    install( FILES  ${CMAKE_BINARY_DIR}/share/metkit/${_file}
             DESTINATION "share/metkit"
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

endforeach()

add_subdirectory( odb )

=== src/experimental/CMakeLists.txt ===
ecbuild_add_executable(

    TARGET netcdf4-example

    CONDITION HAVE_NETCDF

    SOURCES
        netcdf4-example.cc

    INCLUDES
        ${ECKIT_INCLUDE_DIRS}

    LIBS
        eckit
        NetCDF::NetCDF_C
)

=== src/metkit/CMakeLists.txt ===
### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/metkit )

configure_file( metkit_config.h.in    metkit_config.h )
configure_file( metkit_version.h.in   metkit_version.h )
configure_file( metkit_version.cc.in  metkit_version.cc )

install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/metkit_config.h
            ${CMAKE_CURRENT_BINARY_DIR}/metkit_version.h
        DESTINATION
            ${INSTALL_INCLUDE_DIR}/metkit )

### metkit sources

list( APPEND metkit_srcs
    config/LibMetkit.cc
    config/LibMetkit.h
    mars/BaseProtocol.cc
    mars/BaseProtocol.h
    mars/ClientTask.cc
    mars/ClientTask.h
    mars/DHSProtocol.cc
    mars/DHSProtocol.h
    mars/MarsExpandContext.cc
    mars/MarsExpandContext.h
    mars/MarsExpension.cc
    mars/MarsExpension.h
    mars/MarsHandle.cc
    mars/MarsHandle.h
    mars/MarsLanguage.cc
    mars/MarsLanguage.h
    mars/MarsLocation.cc
    mars/MarsLocation.h
    mars/MarsParsedRequest.cc
    mars/MarsParsedRequest.h
    mars/MarsParser.cc
    mars/MarsParser.h
    mars/MarsParserContext.cc
    mars/MarsParserContext.h
    mars/MarsRequest.cc
    mars/MarsRequest.h
    mars/MarsRequestHandle.cc
    mars/MarsRequestHandle.h
    mars/Parameter.cc
    mars/Parameter.h
    mars/ParamID.cc
    mars/ParamID.h
    mars/RequestEnvironment.cc
    mars/RequestEnvironment.h
    mars/StepRangeNormalise.h
    mars/Type.cc
    mars/Type.h
    mars/TypeAny.cc
    mars/TypeAny.h
    mars/TypeDate.cc
    mars/TypeDate.cc
    mars/TypeDate.h
    mars/TypeDate.h
    mars/TypeEnum.cc
    mars/TypeEnum.h
    mars/TypeExpver.cc
    mars/TypeExpver.h
    mars/TypeFloat.cc
    mars/TypeFloat.h
    mars/TypeInteger.cc
    mars/TypeInteger.h
    mars/TypeMixed.cc
    mars/TypeMixed.h
    mars/TypeParam.cc
    mars/TypeParam.h
    mars/TypeRange.cc
    mars/TypeRange.h
    mars/TypeRegex.cc
    mars/TypeRegex.h
    mars/TypesFactory.cc
    mars/TypesFactory.h
    mars/TypeTime.cc
    mars/TypeTime.h
    mars/TypeToByList.cc
    mars/TypeToByList.h
    metkit_version.cc
    tool/MetkitTool.cc
    tool/MetkitTool.h
    fields/FieldIndex.cc
    fields/FieldIndex.h
    fields/FieldIndexList.cc
    fields/FieldIndexList.h
    fields/SimpleFieldIndex.cc
    fields/SimpleFieldIndex.h
    hypercube/HyperCube.cc
    hypercube/HyperCube.h
    hypercube/HyperCubePayloaded.h
)

list( APPEND metkit_persistent_srcs
    mars/Param.cc
    mars/Param.h
    mars/Param
    mars/StepRange.cc
    mars/StepRange.h
    mars/StepRange
)
list( APPEND metkit_srcs ${metkit_persistent_srcs} )

if ( HAVE_GRIB )

    list( APPEND metkit_srcs
        pointdb/bits.h
        pointdb/DataSource.cc
        pointdb/DataSource.h
        pointdb/FieldIndexer.cc
        pointdb/FieldIndexer.h
        pointdb/GribDataSource.cc
        pointdb/GribDataSource.h
        pointdb/GribFieldInfo.cc
        pointdb/GribFieldInfo.h
        pointdb/GribHandleDataSource.cc
        pointdb/GribHandleDataSource.h
        pointdb/masks.h
        pointdb/PointIndex.cc
        pointdb/PointIndex.h
        codes/BUFRDecoder.cc
        codes/BUFRDecoder.h
        codes/GRIBDecoder.cc
        codes/GRIBDecoder.h
        codes/LibEccodes.cc
        codes/LibEccodes.h
        codes/CodesContent.cc
        codes/CodesContent.h
        codes/UserDataContent.cc
        codes/UserDataContent.h
        codes/DataContent.cc
        codes/DataContent.h
        codes/MallocDataContent.cc
        codes/MallocDataContent.h
        codes/CodesSplitter.cc
        codes/CodesSplitter.h
        grib/GribAccessor.cc
        grib/GribAccessor.h
        grib/GribHandle.cc
        grib/GribHandle.h
        grib/GribIterator.cc
        grib/GribIterator.h
        )

    set( grib_libs eccodes )

endif ()

if ( HAVE_ODB )

    list( APPEND metkit_srcs
            odb/IdMapper.cc
            odb/IdMapper.h
            odb/OdbToRequest.cc
            odb/OdbToRequest.h
            codes/OdbDecoder.cc
            codes/OdbContent.cc
            codes/OdbContent.h
            codes/OdbDecoder.h
            codes/OdbSplitter.cc
            codes/OdbSplitter.h
        )
    set( odc_libs odccore )
endif()

ecbuild_add_library(

    TARGET metkit

    INSTALL_HEADERS LISTED

    HEADER_DESTINATION
        ${INSTALL_INCLUDE_DIR}/metkit

    PERSISTENT
        ${metkit_persistent_srcs}

    GENERATED
        metkit_version.cc

    SOURCES
        ${metkit_srcs}

    PUBLIC_INCLUDES
       $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
       $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>

    PRIVATE_LIBS
        "${odc_libs}"

    PUBLIC_LIBS
        eckit
        eckit_option
        ${grib_libs}
)

=== src/tests/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

list(APPEND metkit_env "METKIT_HOME=${CMAKE_BINARY_DIR}")

if( DEFINED ECCODES_DEFINITION_PATH )
  list(APPEND metkit_env "ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH}")
elseif( IS_DIRECTORY "${CMAKE_BINARY_DIR}/share/eccodes/definitions" )
  list(APPEND metkit_env "ECCODES_DEFINITION_PATH=${CMAKE_BINARY_DIR}/share/eccodes/definitions")
endif()


ecbuild_get_test_multidata( TARGET grib_get_data
                            DIRNAME grib_api/data
                            NAMES latlon.grib )

# ecbuild_add_test( TARGET        metkit_test_emosfile
#                   ARGS          --log_level=message
#                   CONDITION     HAVE_GRIB
#                   INCLUDES      "${ECKIT_INCLUDE_DIRS}"
#                   SOURCES       test_emosfile.cc
#                   ENVIRONMENT   "${metkit_env}"
#                   LIBS          metkit
#                   TEST_DEPENDS  grib_get_data
# )


ecbuild_add_test( TARGET        metkit_test_multihandle
                  CONDITION     HAVE_GRIB
                  INCLUDES      "${ECCODES_INCLUDE_DIRS}"
                  SOURCES       test_multihandle.cc
                  LIBS          metkit
                  TEST_DEPENDS  grib_get_data
                  ENVIRONMENT   "${metkit_env}"
)

ecbuild_add_test( TARGET    metkit_test_typesfactory
                  SOURCES   test_typesfactory.cc
                  INCLUDES  "${ECKIT_INCLUDE_DIRS}"
                  ENVIRONMENT   "${metkit_env}"
                  LIBS      metkit )

ecbuild_add_test( TARGET    metkit_test_expand
                  SOURCES   test_expand.cc
                  INCLUDES  "${ECKIT_INCLUDE_DIRS}"
                  ENVIRONMENT   "${metkit_env}"
                  LIBS      metkit)

ecbuild_add_test( TARGET    metkit_test_param_axis
                  SOURCES   test_param_axis.cc
                  INCLUDES  "${ECKIT_INCLUDE_DIRS}"
                  ENVIRONMENT   "${metkit_env}"
                  LIBS      metkit)

ecbuild_add_test( TARGET      metkit_test_steprange_axis
                  SOURCES     test_steprange_axis.cc
                  ENVIRONMENT "${metkit_env}"
                  LIBS        metkit )

ecbuild_add_test( TARGET      metkit_test_time
                  SOURCES     test_time.cc
                  LIBS        metkit )

ecbuild_add_test( TARGET      metkit_test_hypercube
                  SOURCES     test_hypercube.cc
                  LIBS        metkit )

# if ( HAVE_NETCDF )
#    add_subdirectory(netcdf)
# endif()

=== src/tools/CMakeLists.txt ===
### provides MARS requests from GRIB files

# ecbuild_add_executable( TARGET   grib-to-mars-request

#     CONDITION HAVE_GRIB

#     SOURCES  grib-to-mars-request.cc

#     INCLUDES
#         ${ECKIT_INCLUDE_DIRS}

#     LIBS     metkit
# )

# ecbuild_add_executable( TARGET   grib-blob

#     CONDITION HAVE_GRIB

#     SOURCES  grib-blob.cc

#     INCLUDES
#         ${ECKIT_INCLUDE_DIRS}

#     LIBS     metkit eckit_option eckit
# )


# ecbuild_add_executable( TARGET   bufr-to-mars-request

#     CONDITION HAVE_BUFR

#     SOURCES  bufr-to-mars-request.cc

#     INCLUDES ${ECCODES_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS}

#     LIBS     metkit eckit_option eckit eccodes
# )

ecbuild_add_executable(

    TARGET   parse-mars-request

    CONDITION HAVE_GRIB AND HAVE_BUILD_TOOLS

    SOURCES  parse-mars-request.cc

    INCLUDES
        ${ECKIT_INCLUDE_DIRS}

    LIBS     metkit eckit_option eckit eccodes
)

ecbuild_add_executable(

    TARGET    odb-to-request
    SOURCES   odb-to-request.cc
    CONDITION HAVE_ODB2 AND HAVE_BUILD_TOOLS
    INCLUDES  ${ECKIT_INCLUDE_DIRS}
    LIBS      metkit eckit_option )

# ecbuild_add_executable( TARGET     ncmerge
#                         SOURCES    ncmerge.cc
#                         CONDITION  HAVE_NETCDF
#                         LIBS       metkit NetCDF::NetCDF_C )


if(HAVE_BUILD_TOOLS)
  file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/nccompare.py
    DESTINATION ${CMAKE_BINARY_DIR}/bin
    FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )
endif()

=== debian/changelog ===
metkit (1.6.4-2) unstable; urgency=medium

  * Add Breaks/Replaces on old libodb-api-0d. Closes: #985117

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 13 Mar 2021 11:18:49 +0000

metkit (1.6.4-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.5.1
  * Add debian/watch file
  * Add d/gpb.conf pointing to DEP-14 branches

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 22 Jan 2021 13:08:51 +0000

metkit (1.6.0-4) unstable; urgency=medium

  * Make dependency on libodc-dev conditional; fails on 32-bit archs

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 07 Nov 2020 12:23:11 +0000

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
  ecbuild (>= 3.3.0-3),
  gfortran | fortran-compiler, 
  libeckit-dev,
- libodc-dev,
+ libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
+ odc [!powerpc !armel !armhf !i386 !mipsel],
  libeccodes-dev,
  libeccodes-tools,
  libnetcdf-dev,
  libopenjp2-7-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/ecmwf/metkit
 Vcs-Browser: https://salsa.debian.org:/science-team/metkit.git
 Vcs-Git: https://salsa.debian.org:/science-team/metkit.git -b debian/latest
@@ -21,6 +22,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, libmetkit-data
+Breaks: libodb-api-0d
+Replaces: libodb-api-0d
 Description: Library for Meteorology tookit, implementing MARS language
  MetKit is a toolkit from ECMWF for manipulating and describing 
  meteorological objects, implementing the MARS language and associated 
@@ -44,7 +47,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: libmetkit0d (= ${binary:Version}), 
-  ${misc:Depends}, libeckit-dev
+  ${misc:Depends}, libeckit-dev,
+  libodc-dev [!powerpc !armel !armhf !i386 !mipsel]
 Replaces: libodb-api-dev
 Conflicts: libodb-api-dev
 Recommends: pkg-config

=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,17 @@
   FC:=$(shell basename $(shell readlink /etc/alternatives/f77))
 endif
 
+# Fixes for 32-bit archss
+ARCH_32BIT:=   i386 armel armhf mipsel hppa hurd-i386 m68k powerpc sh4 x32
+DO_ODB:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_32BIT)),OFF,ON)
+
 # The magic debhelper  rule
 %:
 	dh $@ --buildsystem=ecbuild
 
 CMAKE_CFLAGS:= -DENABLE_FORTRAN=ON \
 		-DENABLE_RPATH=OFF \
+		-DENABLE_ODB=$(DO_ODB) \
 		-DENABLE_RELATIVE_RPATHS=OFF
 
 override_dh_auto_configure:

## metkit 1.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
 
 set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support
 
-ecbuild_find_package( NAME eckit  VERSION  1.11 REQUIRED )
+ecbuild_find_package( NAME eckit  VERSION  1.16 REQUIRED )
 
 ############################################################################################
 # sources

=== share/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-list( APPEND files language.yaml paramids.yaml params.yaml wind )
+list( APPEND files language.yaml paramids.yaml params.yaml axis.yaml wind )
 
 foreach( _file ${files} )

=== src/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -137,12 +137,12 @@
         codes/MallocDataContent.h
         codes/CodesSplitter.cc
         codes/CodesSplitter.h
-        grib/GribAccessor.cc
-        grib/GribAccessor.h
-        grib/GribHandle.cc
-        grib/GribHandle.h
-        grib/GribIterator.cc
-        grib/GribIterator.h
+        codes/GribAccessor.cc
+        codes/GribAccessor.h
+        codes/GribHandle.cc
+        codes/GribHandle.h
+        codes/GribIterator.cc
+        codes/GribIterator.h
         )
 
     set( grib_libs eccodes )
@@ -156,12 +156,14 @@
             odb/IdMapper.h
             odb/OdbToRequest.cc
             odb/OdbToRequest.h
-            codes/OdbDecoder.cc
-            codes/OdbContent.cc
-            codes/OdbContent.h
-            codes/OdbDecoder.h
-            codes/OdbSplitter.cc
-            codes/OdbSplitter.h
+            odb/OdbMetadataDecoder.cc
+            odb/OdbMetadataDecoder.h
+            odb/OdbDecoder.cc
+            odb/OdbContent.cc
+            odb/OdbContent.h
+            odb/OdbDecoder.h
+            odb/OdbSplitter.cc
+            odb/OdbSplitter.h
         )
     set( odc_libs odccore )
 endif()

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -54,7 +54,7 @@
 
     TARGET    odb-to-request
     SOURCES   odb-to-request.cc
-    CONDITION HAVE_ODB2 AND HAVE_BUILD_TOOLS
+    CONDITION HAVE_ODB AND HAVE_BUILD_TOOLS
     INCLUDES  ${ECKIT_INCLUDE_DIRS}
     LIBS      metkit eckit_option )

=== debian/changelog ===
metkit (1.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 02 May 2021 07:05:58 +0100

metkit (1.7.0-1) unstable; urgency=medium

  * New upstream release
  * Add versioned build-dep on libeckit-dev >= 1.16.0-1~

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Mar 2021 16:35:19 +0000

## metkit 1.8.3

=== share/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-list( APPEND files language.yaml paramids.yaml params.yaml axis.yaml wind )
+list( APPEND files language.yaml paramids.yaml params.yaml params-static.yaml axis.yaml wind )
 
 foreach( _file ${files} )

=== src/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -80,6 +80,8 @@
     mars/TypeTime.h
     mars/TypeToByList.cc
     mars/TypeToByList.h
+    mars/TypeToByListFloat.cc
+    mars/TypeToByListFloat.h
     metkit_version.cc
     tool/MetkitTool.cc
     tool/MetkitTool.h

=== debian/changelog ===
metkit (1.8.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 31 May 2021 08:29:42 +0100

metkit (1.8.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 27 May 2021 14:56:22 +0100

metkit (1.8.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 23 May 2021 14:24:11 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (=13),
  ecbuild (>= 3.3.0-3),
  gfortran | fortran-compiler, 
- libeckit-dev,
+ libeckit-dev (>= 1.16.0-1~),
  libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
  odc [!powerpc !armel !armhf !i386 !mipsel],
  libeccodes-dev,

## metkit 1.8.4

=== debian/changelog ===
metkit (1.8.4-1) unstable; urgency=medium

  * New upstream release
    * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 28 Aug 2021 12:43:10 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libeccodes-tools,
  libnetcdf-dev,
  libopenjp2-7-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/ecmwf/metkit
 Vcs-Browser: https://salsa.debian.org:/science-team/metkit.git
 Vcs-Git: https://salsa.debian.org:/science-team/metkit.git -b debian/latest

## metkit 1.8.8

=== debian/changelog ===
metkit (1.8.8-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Dec 2021 09:52:57 +0000

metkit (1.8.4-2) unstable; urgency=medium

  * Build on 64-bit archs only, as we depend on 64-bit eckit

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Oct 2021 09:17:03 +0100

## metkit 1.8.10

=== share/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-list( APPEND files language.yaml paramids.yaml params.yaml params-static.yaml axis.yaml wind )
+list( APPEND files language.yaml paramids.yaml params.yaml params-static.yaml param-matching.yaml axis.yaml )
 
 foreach( _file ${files} )

=== src/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
 ### metkit sources
 
 list( APPEND metkit_srcs
+    ${CMAKE_CURRENT_BINARY_DIR}/metkit_version.cc
     config/LibMetkit.cc
     config/LibMetkit.h
     mars/BaseProtocol.cc
@@ -82,7 +83,6 @@
     mars/TypeToByList.h
     mars/TypeToByListFloat.cc
     mars/TypeToByListFloat.h
-    metkit_version.cc
     tool/MetkitTool.cc
     tool/MetkitTool.h
     fields/FieldIndex.cc
@@ -182,9 +182,6 @@
     PERSISTENT
         ${metkit_persistent_srcs}
 
-    GENERATED
-        metkit_version.cc
-
     SOURCES
         ${metkit_srcs}

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -36,23 +36,14 @@
 #     LIBS     metkit eckit_option eckit eccodes
 # )
 
-ecbuild_add_executable(
-
-    TARGET   parse-mars-request
-
+ecbuild_add_executable( TARGET    parse-mars-request
     CONDITION HAVE_GRIB AND HAVE_BUILD_TOOLS
-
-    SOURCES  parse-mars-request.cc
-
-    INCLUDES
-        ${ECKIT_INCLUDE_DIRS}
-
-    LIBS     metkit eckit_option eckit eccodes
+    SOURCES   parse-mars-request.cc
+    INCLUDES  ${ECKIT_INCLUDE_DIRS}
+    LIBS        metkit eckit_option eckit eccodes
 )
 
-ecbuild_add_executable(
-
-    TARGET    odb-to-request
+ecbuild_add_executable( TARGET    odb-to-request
     SOURCES   odb-to-request.cc
     CONDITION HAVE_ODB AND HAVE_BUILD_TOOLS
     INCLUDES  ${ECKIT_INCLUDE_DIRS}

=== tests/netcdf/CMakeLists.txt ===
# two_dimensions_merge
list(APPEND merge_tests_ok simple_two_way_merge
        simple_three_way_merge
        complex_two_way_merge
        type_upgrade_merge
        attribute_merge
        multi_merge
        multi_dimensions_merge
        signature_merge_1
        signature_merge_2
        new_missing_values_merge
        new_dimension_merge_1
        new_dimension_merge_2
        retype_merge
        coordinates_overlap_merge_1
        coordinates_overlap_merge_2
        coordinates_overlap_merge_3
        coordinates_overlap_merge_4
        coordinates_overlap_merge_5
        coordinates_overlap_merge_6
        date_merge_1
        date_merge_2
        variable_merge_1
        variable_merge_2
        variable_merge_3
        variable_merge_4
        variable_merge_5
        bounds_merge_1
        bounds_merge_2
        monotonic
        )

list(APPEND merge_tests_fail bounds_merge)
list(APPEND merge_tests_only coordinates_overlap_merge)

foreach(_TEST
    bounds_merge_2
    # ${merge_tests_ok}
    )
    ecbuild_add_test( TARGET "nccombine_${_TEST}"
                      ENVIRONMENT   "${metkit_env}"
                      COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/${_TEST}.sh")
endforeach()

=== tests/regressions/CMakeLists.txt ===
if (HAVE_BUILD_TOOLS) # test scripts use the metkit tools
    add_subdirectory(METK-89)
endif()

=== tests/regressions/METK-89/CMakeLists.txt ===
ecbuild_configure_file( METK-89.sh.in METK-89.sh @ONLY )

ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  METK-89.sh )

=== debian/changelog ===
metkit (1.8.10-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Feb 2022 09:57:08 +0000

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 Package: libmetkit0d
 Section: libs
-Architecture: any
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, libmetkit-data
 Breaks: libodb-api-0d
@@ -44,7 +44,7 @@
 
 Package: libmetkit-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Multi-Arch: same
 Depends: libmetkit0d (= ${binary:Version}), 
   ${misc:Depends}, libeckit-dev,
@@ -61,7 +61,7 @@
 
 Package: libmetkit-utils
 Multi-Arch: foreign
-Architecture: any
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Depends: libmetkit0d ( = ${binary:Version}), 
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: libmetkit-dev (= ${binary:Version})

## metkit 1.9.0

=== debian/changelog ===
metkit (1.9.0-1) unstable; urgency=medium

  * Initial bash completion script
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 05 Mar 2022 13:19:35 +0000

## metkit 1.9.1

=== debian/changelog ===
metkit (1.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 19 May 2022 19:38:24 +0100

## metkit 1.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,6 +69,7 @@
 
 add_subdirectory( src )
 add_subdirectory( share )
+add_subdirectory( tests )
 
 ############################################################################################
 # finalize

=== tests/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

list(APPEND metkit_env "METKIT_HOME=${CMAKE_BINARY_DIR}")

if( DEFINED ECCODES_DEFINITION_PATH )
  list(APPEND metkit_env "ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH}")
elseif( IS_DIRECTORY "${CMAKE_BINARY_DIR}/share/eccodes/definitions" )
  list(APPEND metkit_env "ECCODES_DEFINITION_PATH=${CMAKE_BINARY_DIR}/share/eccodes/definitions")
endif()


ecbuild_get_test_multidata( TARGET grib_get_data
                            DIRNAME grib_api/data
                            NAMES latlon.grib )

# ecbuild_add_test( TARGET        metkit_test_emosfile
#                   ARGS          --log_level=message
#                   CONDITION     HAVE_GRIB
#                   INCLUDES      "${ECKIT_INCLUDE_DIRS}"
#                   SOURCES       test_emosfile.cc
#                   ENVIRONMENT   "${metkit_env}"
#                   LIBS          metkit
#                   TEST_DEPENDS  grib_get_data
# )


ecbuild_add_test( TARGET        metkit_test_multihandle
                  CONDITION     HAVE_GRIB
                  INCLUDES      "${ECCODES_INCLUDE_DIRS}"
                  SOURCES       test_multihandle.cc
                  LIBS          metkit
                  TEST_DEPENDS  grib_get_data
                  ENVIRONMENT   "${metkit_env}"
)

ecbuild_add_test( TARGET    metkit_test_typesfactory
                  SOURCES   test_typesfactory.cc
                  INCLUDES  "${ECKIT_INCLUDE_DIRS}"
                  ENVIRONMENT   "${metkit_env}"
                  LIBS      metkit )

ecbuild_add_test( TARGET    metkit_test_expand
                  SOURCES   test_expand.cc
                  INCLUDES  "${ECKIT_INCLUDE_DIRS}"
                  ENVIRONMENT   "${metkit_env}"
                  LIBS      metkit)

ecbuild_add_test( TARGET    metkit_test_param_axis
                  SOURCES   test_param_axis.cc
                  INCLUDES  "${ECKIT_INCLUDE_DIRS}"
                  ENVIRONMENT   "${metkit_env}"
                  LIBS      metkit)

ecbuild_add_test( TARGET      metkit_test_steprange_axis
                  SOURCES     test_steprange_axis.cc
                  ENVIRONMENT "${metkit_env}"
                  LIBS        metkit )

ecbuild_add_test( TARGET      metkit_test_time
                  SOURCES     test_time.cc
                  LIBS        metkit )

ecbuild_add_test( TARGET      metkit_test_hypercube
                  SOURCES     test_hypercube.cc
                  LIBS        metkit )

# if ( HAVE_NETCDF )
#    add_subdirectory(netcdf)
# endif()

add_subdirectory(regressions)

=== share/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-list( APPEND files language.yaml paramids.yaml params.yaml params-static.yaml param-matching.yaml axis.yaml )
+list( APPEND files language.yaml paramids.yaml params.yaml params-static.yaml param-matching.yaml bufr-subtypes.yaml axis.yaml )
 
 foreach( _file ${files} )

=== src/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -48,6 +48,8 @@
     mars/Parameter.h
     mars/ParamID.cc
     mars/ParamID.h
+    mars/Quantile.cc
+    mars/Quantile.h
     mars/RequestEnvironment.cc
     mars/RequestEnvironment.h
     mars/StepRangeNormalise.h
@@ -83,6 +85,8 @@
     mars/TypeToByList.h
     mars/TypeToByListFloat.cc
     mars/TypeToByListFloat.h
+    mars/TypeToByListQuantile.cc
+    mars/TypeToByListQuantile.h
     tool/MetkitTool.cc
     tool/MetkitTool.h
     fields/FieldIndex.cc
@@ -131,6 +135,8 @@
         codes/LibEccodes.h
         codes/CodesContent.cc
         codes/CodesContent.h
+        codes/BufrContent.cc
+        codes/BufrContent.h
         codes/UserDataContent.cc
         codes/UserDataContent.h
         codes/DataContent.cc

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -49,6 +49,12 @@
     INCLUDES  ${ECKIT_INCLUDE_DIRS}
     LIBS      metkit eckit_option )
 
+ecbuild_add_executable( TARGET    bufr-sanity-check
+    SOURCES   bufr-sanity-check.cc
+    CONDITION HAVE_BUILD_TOOLS
+    INCLUDES  ${ECKIT_INCLUDE_DIRS}
+    LIBS      metkit eckit_option )
+
 # ecbuild_add_executable( TARGET     ncmerge
 #                         SOURCES    ncmerge.cc
 #                         CONDITION  HAVE_NETCDF

=== debian/changelog ===
metkit (1.9.2-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Aug 2022 11:42:19 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libeccodes-tools,
  libnetcdf-dev,
  libopenjp2-7-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/ecmwf/metkit
 Vcs-Browser: https://salsa.debian.org:/science-team/metkit.git
 Vcs-Git: https://salsa.debian.org:/science-team/metkit.git -b debian/latest

## metkit 1.10.13

=== debian/changelog ===
metkit (1.10.13-2build1) mantic; urgency=medium

  * Rebuild against new eccodes drop on armhf and s390x.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 20 Jul 2023 07:04:34 +0200

metkit (1.10.13-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Jun 2023 10:28:02 +0100

metkit (1.10.13-1) experimental; urgency=medium

  * New upstream release
  * Depend on eckit >= 1.23.1

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 17 May 2023 10:07:49 +0100

metkit (1.10.11-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 May 2023 14:19:55 +0100

metkit (1.10.9-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 27 Apr 2023 10:43:50 +0100

metkit (1.10.8-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 25 Apr 2023 15:02:54 +0100

metkit (1.10.7-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 15 Apr 2023 13:00:44 +0100

metkit (1.10.5-1) experimental; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.2
  * Build-dep on ecbuild >= 3.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 09 Apr 2023 09:28:26 +0100

metkit (1.10.4-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 18 Mar 2023 08:24:28 +0000

metkit (1.10.3-1) experimental; urgency=medium

  * New upstream release
  * Now dep on  eckit >= 1.22.0-1~

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Mar 2023 12:05:25 +0000

## metkit 1.10.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
 
-find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
+find_package( ecbuild 3.7.2 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
 
 project( metkit LANGUAGES CXX )
 
@@ -31,15 +31,15 @@
 
 ecbuild_add_option( FEATURE GRIB
                     DEFAULT ON
-                    DESCRIPTION "Add support for GRIB format (grib_api not supported)"
-                    REQUIRED_PACKAGES "NAME eccodes VERSION 2.5" )
+                    DESCRIPTION "Add support for GRIB format"
+                    REQUIRED_PACKAGES "NAME eccodes VERSION 2.27" )
 
 # BUFR support
 
 ecbuild_add_option( FEATURE BUFR
-                    DEFAULT OFF
-                    DESCRIPTION "Add support for BUFR4 format"
-                    REQUIRED_PACKAGES "NAME eccodes VERSION 2.8" )
+                    DEFAULT ON
+                    DESCRIPTION "Add support for BUFR format"
+                    REQUIRED_PACKAGES "NAME eccodes VERSION 2.27" )
 
 # netcdf support
 
@@ -56,6 +56,10 @@
                     DESCRIPTION "Add support for ODB data"
                     REQUIRED_PACKAGES "NAME odc VERSION 1.0" )
 
+# Temporary
+ecbuild_add_option( FEATURE FAIL_ON_CCSDS
+                    DESCRIPTION "Fail on CCSDS"
+                    DEFAULT OFF	 )
 # eckit
 
 set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

=== tests/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

list(APPEND metkit_env "METKIT_HOME=${CMAKE_BINARY_DIR}")

if( DEFINED ECCODES_DEFINITION_PATH )
  list(APPEND metkit_env "ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH}")
elseif( IS_DIRECTORY "${CMAKE_BINARY_DIR}/share/eccodes/definitions" )
  list(APPEND metkit_env "ECCODES_DEFINITION_PATH=${CMAKE_BINARY_DIR}/share/eccodes/definitions")
endif()


ecbuild_get_test_multidata( TARGET grib_get_data
                            DIRNAME grib_api/data
                            NAMES latlon.grib )

ecbuild_get_test_multidata( TARGET metkit_get_odb_data
                            NAMES multiodb.odb
                                  multiodb2.odb )

# ecbuild_add_test( TARGET        metkit_test_emosfile
#                   ARGS          --log_level=message
#                   CONDITION     HAVE_GRIB
#                   INCLUDES      "${ECKIT_INCLUDE_DIRS}"
#                   SOURCES       test_emosfile.cc
#                   ENVIRONMENT   "${metkit_env}"
#                   LIBS          metkit
#                   TEST_DEPENDS  grib_get_data
# )


ecbuild_add_test( TARGET        metkit_test_multihandle
                  CONDITION     HAVE_GRIB
                  INCLUDES      "${ECCODES_INCLUDE_DIRS}"
                  SOURCES       test_multihandle.cc
                  LIBS          metkit
                  NO_AS_NEEDED
                  TEST_DEPENDS  grib_get_data
                  ENVIRONMENT   "${metkit_env}"
)

ecbuild_add_test( TARGET      "metkit_test_codes_decoder"
                  CONDITION   HAVE_GRIB OR HAVE_BUFR
                  SOURCES     "test_codes_decoder.cc"
                  INCLUDES    "${ECKIT_INCLUDE_DIRS}" "${ECCODES_INCLUDE_DIR}"
                  LIBS        metkit
                  NO_AS_NEEDED
                  ENVIRONMENT "${metkit_env}"
)

ecbuild_add_test( TARGET        metkit_test_odbsplitter
                  CONDITION     HAVE_ODB
                  SOURCES       test_odbsplitter.cc
                  INCLUDES      "${ECKIT_INCLUDE_DIRS}"
                  TEST_DEPENDS  metkit_get_odb_data
                  NO_AS_NEEDED
                  LIBS          metkit )

list(APPEND testFileSuffixes typesfactory expand param_axis steprange_axis time hypercube )

foreach(test IN LISTS testFileSuffixes)
    ecbuild_add_test( TARGET    "metkit_test_${test}"
                      SOURCES   "test_${test}.cc"
                      INCLUDES  "${ECKIT_INCLUDE_DIRS}"
                      ENVIRONMENT   "${metkit_env}"
                      NO_AS_NEEDED
                      LIBS      metkit)
endforeach()

# if ( HAVE_NETCDF )
#    add_subdirectory(netcdf)
# endif()

add_subdirectory(regressions)

=== src/metkit/CMakeLists.txt ===
--- 
+++ 
@@ -127,6 +127,7 @@
         pointdb/masks.h
         pointdb/PointIndex.cc
         pointdb/PointIndex.h
+        codes/CodesDecoder.h
         codes/BUFRDecoder.cc
         codes/BUFRDecoder.h
         codes/GRIBDecoder.cc
@@ -141,8 +142,8 @@
         codes/UserDataContent.h
         codes/DataContent.cc
         codes/DataContent.h
-        codes/MallocDataContent.cc
-        codes/MallocDataContent.h
+        codes/MallocCodesContent.cc
+        codes/MallocCodesContent.h
         codes/CodesSplitter.cc
         codes/CodesSplitter.h
         codes/GribAccessor.cc
@@ -151,6 +152,7 @@
         codes/GribHandle.h
         codes/GribIterator.cc
         codes/GribIterator.h
+        codes/CodesHandleDeleter.h
         )
 
     set( grib_libs eccodes )

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -41,18 +41,21 @@
     SOURCES   parse-mars-request.cc
     INCLUDES  ${ECKIT_INCLUDE_DIRS}
     LIBS        metkit eckit_option eckit eccodes
+    NO_AS_NEEDED
 )
 
 ecbuild_add_executable( TARGET    odb-to-request
     SOURCES   odb-to-request.cc
     CONDITION HAVE_ODB AND HAVE_BUILD_TOOLS
     INCLUDES  ${ECKIT_INCLUDE_DIRS}
+    NO_AS_NEEDED
     LIBS      metkit eckit_option )
 
 ecbuild_add_executable( TARGET    bufr-sanity-check
     SOURCES   bufr-sanity-check.cc
-    CONDITION HAVE_BUILD_TOOLS
+    CONDITION HAVE_BUFR AND HAVE_BUILD_TOOLS
     INCLUDES  ${ECKIT_INCLUDE_DIRS}
+    NO_AS_NEEDED
     LIBS      metkit eckit_option )
 
 # ecbuild_add_executable( TARGET     ncmerge

=== debian/changelog ===
metkit (1.10.14-1) unstable; urgency=medium

  * New upstream release 
  * Put include files in /usr/include/arch/ for multiarch-safe

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Aug 2023 09:15:51 +0100

=== debian/control ===
Source: metkit
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 ecbuild (>= 3.7.2-1~),
 gfortran | fortran-compiler,
 libeckit-dev (>= 1.23.1-1~),
 libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
 odc [!powerpc !armel !armhf !i386 !mipsel],
 libeccodes-dev,
 libeccodes-tools,
 libnetcdf-dev,
 libopenjp2-7-dev
Standards-Version: 4.6.2
Homepage: https://github.com/ecmwf/metkit
Vcs-Browser: https://salsa.debian.org:/science-team/metkit.git
Vcs-Git: https://salsa.debian.org/science-team/metkit.git -b debian/latest

Package: libmetkit0d
Section: libs
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetkit-data
Breaks: libodb-api-0d
Replaces: libodb-api-0d
Description: Library for Meteorology tookit, implementing MARS language
 MetKit is a toolkit from ECMWF for manipulating and describing
 meteorological objects, implementing the MARS language and associated
 processing and semantics.
 MARS is the Meteorological Archive Retrieval System from ECMWF.

Package: libmetkit-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: libodb-api-data
Description: Data used by the ECMWF Metkit Library
 MetKit is a toolkit from ECMWF for manipulating and describing
 meteorological objects, implementing the MARS language and associated
 processing and semantics.
 .
 This package contains data used by Metkit

Package: libmetkit-dev
Section: libdevel
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
Multi-Arch: same
Depends: libmetkit0d (= ${binary:Version}),
  ${misc:Depends}, libeckit-dev,
  libodc-dev [!powerpc !armel !armhf !i386 !mipsel]
Replaces: libodb-api-dev
Conflicts: libodb-api-dev
Recommends: pkg-config
Description: Development files for the Metkit toolkit
 MetKit is a toolkit from ECMWF for manipulating and describing
 meteorological objects, implementing the MARS language and associated
 processing and semantics.
 .
 This package provides shared libraries and headers.

Package: libmetkit-utils
Multi-Arch: foreign
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
Depends: libmetkit0d ( = ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libmetkit-dev (= ${binary:Version})
Description: Utilities for the MetKit MARS access library
 MetKit is a toolkit from ECMWF for manipulating and describing
 meteorological objects, implementing the MARS language and associated
 processing and semantics.
 .
 This package contains the tool 'parse-mars-request'

=== debian/rules ===
--- 
+++ 
@@ -27,4 +27,3 @@
 
 override_dh_auto_test:
 	echo "Metkit fetches data from the internet, and hence the tests can't be run contained at build-time"
-

## metkit 1.10.19

=== debian/changelog ===
metkit (1.10.19-1) unstable; urgency=medium

  * New upstream release
  * Explicitly depend on architecture-is-64-bit to limit archs

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 28 Oct 2023 07:54:09 +0100

metkit (1.10.17-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Oct 2023 08:30:58 +0100

metkit (1.10.16-1) unstable; urgency=medium

  * New upstrem release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 12 Oct 2023 08:50:45 +0100

metkit (1.10.15-2) unstable; urgency=medium

  * Drop 32-bit stuff from d/rules; we only build on 64-bit
  * Fix path of include dirs in metkit-config.cmake

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 18 Sep 2023 11:48:07 +0100

metkit (1.10.15-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 06 Sep 2023 15:24:03 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (=13),
+ architecture-is-64-bit,
  ecbuild (>= 3.7.2-1~),
  gfortran | fortran-compiler,
  libeckit-dev (>= 1.23.1-1~),
- libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
- odc [!powerpc !armel !armhf !i386 !mipsel],
+ libodc-dev,
+ odc,
  libeccodes-dev,
  libeccodes-tools,
- libnetcdf-dev,
  libopenjp2-7-dev
 Standards-Version: 4.6.2
 Homepage: https://github.com/ecmwf/metkit
@@ -19,7 +19,7 @@
 
 Package: libmetkit0d
 Section: libs
-Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
+Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, libmetkit-data
 Breaks: libodb-api-0d
@@ -44,7 +44,7 @@
 
 Package: libmetkit-dev
 Section: libdevel
-Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
+Architecture: any
 Multi-Arch: same
 Depends: libmetkit0d (= ${binary:Version}),
   ${misc:Depends}, libeckit-dev,
@@ -61,7 +61,7 @@
 
 Package: libmetkit-utils
 Multi-Arch: foreign
-Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
+Architecture: any
 Depends: libmetkit0d ( = ${binary:Version}),
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: libmetkit-dev (= ${binary:Version})

## metkit 1.10.20

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -77,3 +77,4 @@
 # endif()
 
 add_subdirectory(regressions)
+add_subdirectory(marsgen)

=== debian/changelog ===
metkit (1.10.20-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 02 Nov 2023 17:26:21 +0000
